import matplotlib.pyplot as plt
import numpy as np

idx0=[19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,94,95,96,97,98,99,100,101,102,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,]
idx1=[92,94,95,96,97,98,99,100,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,]
idx2=[191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,242,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,]
idx3=[287,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399,400,401,402,403,404,405,406,407,408,409,410,411,412,413,414,415,416,417,418,419,420,421,423,]
his0=[2,15,16,18,19,18,15,17,22,19,26,25,20,20,20,13,17,17,17,28,21,23,18,24,21,20,24,22,22,17,21,18,15,27,26,30,16,16,16,27,13,18,20,21,21,25,14,20,28,14,21,22,23,19,22,22,20,18,26,19,13,14,21,16,20,15,25,28,85,113,110,51,24,4,3,24,105,129,102,51,27,9,1,1,12,12,11,15,12,20,18,28,25,23,23,25,28,20,18,16,6,3,]
his1=[1,5,13,25,29,21,13,8,3,8,13,22,28,15,21,20,17,27,19,13,17,17,25,24,18,25,22,23,18,24,23,24,16,17,17,21,28,34,15,17,20,15,15,20,21,18,20,27,20,15,21,21,25,22,13,21,22,26,24,24,16,17,14,16,26,15,15,25,29,34,75,86,90,55,36,18,10,19,43,91,101,82,66,44,26,20,12,8,8,2,3,4,10,12,21,20,25,34,24,25,15,22,14,12,3,1,]
his2=[2,6,8,12,21,24,33,31,32,19,9,8,8,3,4,10,6,10,23,25,21,16,21,17,30,31,28,31,29,22,7,9,3,2,1,4,7,7,15,12,16,19,15,26,25,19,23,19,19,20,19,16,23,15,16,27,20,20,19,24,18,24,17,29,25,23,16,17,16,18,17,22,19,9,25,57,48,66,71,71,50,34,24,30,40,66,79,68,59,66,42,28,17,14,15,7,4,5,5,16,12,21,24,25,27,23,21,15,15,14,11,7,1,]
his3=[1,1,1,10,12,13,21,23,29,30,23,17,11,11,11,6,6,10,13,14,17,26,12,20,26,21,37,29,37,33,34,23,16,14,12,10,5,11,14,16,16,18,21,21,15,23,21,29,27,26,24,19,17,10,9,3,5,3,4,5,4,8,19,9,21,16,21,30,23,14,13,20,17,20,19,24,23,43,44,47,58,61,48,54,46,34,44,51,60,65,66,62,37,46,27,21,21,14,13,4,9,9,16,16,20,22,21,18,23,18,20,13,11,12,6,3,3,1,]

# creating the bar plot

y0 = sum(his0) - np.cumsum(his0)
y1 = sum(his2) - np.cumsum(his1)
y2 = sum(his3) - np.cumsum(his2)
y3 = sum(his3) - np.cumsum(his3)

x0 = np.array(idx0)
x1 = np.array(idx1)
x2 = np.array(idx2)
x3 = np.array(idx3)

plt.rc('font', size=20)
plt.plot(x0, y0, x1, y1, x2, y2, x3, y3, linewidth=5)

plt.vlines(x = [120, 240, 360, 480], ymin =  sum(his0) - 1500, ymax = sum(his0), colors = 'black',
           label = 'vline_single - full height')

plt.legend(["First Message", "Second Message", "Third Message", "Fourth Message"], fontsize=18, loc="lower left")
plt.xlabel("Write-to-receive latency [us]", fontsize=20)
plt.ylabel("Message Count", fontsize=20)
plt.yscale('log')
plt.xlim(0)
plt.title("CAN High Priority Message Latency Profile for 10,000 Messages in Burst of Size 4", fontsize=25)
plt.show()


plt.show()
